/**
 * Segment Public API
 * The Segment Public API helps you manage your Segment Workspaces and its resources. You can use the API to perform CRUD (create, read, update, delete) operations at no extra charge. This includes working with resources such as Sources, Destinations, Warehouses, Tracking Plans, and the Segment Destinations and Sources Catalogs.  All CRUD endpoints in the API follow REST conventions and use standard HTTP methods. Different URL endpoints represent different resources in a Workspace.  See the next sections for more information on how to use the Segment Public API.
 *
 * The version of the OpenAPI document: 58.5.0
 * Contact: friends@segment.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';

/**
 * Create a new Warehouse based on a set of parameters.
 */
export class CreateWarehouseV1Input {
    /**
     * The Warehouse metadata to use.
     */
    'metadataId': string;
    /**
     * An optional human-readable name for this Warehouse.
     */
    'name'?: string;
    /**
     * Enable to allow this Warehouse to receive data. Defaults to true.
     */
    'enabled'?: boolean;
    /**
     * A key-value object that contains instance-specific Warehouse settings.
     */
    'settings': { [key: string]: any };
    /**
     * Whether to disconnect all Sources from this Warehouse.
     */
    'disconnectAllSources'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }> = [
        {
            name: 'metadataId',
            baseName: 'metadataId',
            type: 'string',
        },
        {
            name: 'name',
            baseName: 'name',
            type: 'string',
        },
        {
            name: 'enabled',
            baseName: 'enabled',
            type: 'boolean',
        },
        {
            name: 'settings',
            baseName: 'settings',
            type: '{ [key: string]: any; }',
        },
        {
            name: 'disconnectAllSources',
            baseName: 'disconnectAllSources',
            type: 'boolean',
        },
    ];

    static getAttributeTypeMap() {
        return CreateWarehouseV1Input.attributeTypeMap;
    }
}
