/**
 * Segment Public API
 * The Segment Public API helps you manage your Segment Workspaces and its resources. You can use the API to perform CRUD (create, read, update, delete) operations at no extra charge. This includes working with resources such as Sources, Destinations, Warehouses, Tracking Plans, and the Segment Destinations and Sources Catalogs.  All CRUD endpoints in the API follow REST conventions and use standard HTTP methods. Different URL endpoints represent different resources in a Workspace.  See the next sections for more information on how to use the Segment Public API.
 *
 * The version of the OpenAPI document: 58.5.0
 * Contact: friends@segment.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';

/**
 * Sort criteria input for list audience consumers.
 */
export class ListAudienceConsumersSortInput {
    /**
     * Field to sort by.
     */
    'field': ListAudienceConsumersSortInput.FieldEnum;
    /**
     * Sort direction (ascending or descending).
     */
    'direction': ListAudienceConsumersSortInput.DirectionEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }> = [
        {
            name: 'field',
            baseName: 'field',
            type: 'ListAudienceConsumersSortInput.FieldEnum',
        },
        {
            name: 'direction',
            baseName: 'direction',
            type: 'ListAudienceConsumersSortInput.DirectionEnum',
        },
    ];

    static getAttributeTypeMap() {
        return ListAudienceConsumersSortInput.attributeTypeMap;
    }
}

export namespace ListAudienceConsumersSortInput {
    export enum FieldEnum {
        CREATED_AT = <any>'CREATED_AT',
        NAME = <any>'NAME',
        UPDATED_AT = <any>'UPDATED_AT',
    }
    export enum DirectionEnum {
        ASC = <any>'ASC',
        DESC = <any>'DESC',
    }
}
